# demarchessimplifiees

## Table of Contents

1. [Description](#description)
1. [Setup - The basics of getting started with demarchessimplifiees](#setup)
    * [What demarchessimplifiees affects](#what-demarchessimplifiees-affects)
    * [Setup requirements](#setup-requirements)
    * [Beginning with demarchessimplifiees](#beginning-with-demarchessimplifiees)
1. [Usage - Configuration options and additional functionality](#usage)
1. [Limitations - OS compatibility, etc.](#limitations)
1. [Development - Guide for contributing to the module](#development)

## Description

This Puppet module install and configure [Demarches Simplfiees](https://beta.gouv.fr/startups/demarches-simplifiees.fr.html) component, aka DS.

## Setup

### What demarchessimplifiees affects

The module can :
 * install and configure a PostgreSQL backend.
 * install Ruby with Rbenv. This will install some dev packages to be able to compile Ruby.
 * install NodeJS from Nodesource and so it will add a new source in the package manager.
 * install Yarn
 * create an OS local account owner of files.

By default, it will do all of them. It is possible to disable these actions with the `$*_manage` parameters.

The clock hosting Demarches Simplifiées have to be on time for OTP (One Time Password).

### Setup Requirements

All required modules and supported versions of Puppet are listed in `metadata.json`.

### Beginning with demarchessimplifiees

With the default behavior it is possible to simply use :

```
include demarchessimplifiees
```

## Usage

### When DS uses a remote PostgreSQL service

This will not install a PostreSQL server locally and use a remote one :
```
  class { 'demarchessimplifiees':
    database_host     => '10.10.10.10',
    postgresql_manage => false,
  }
```

### When DS files have to be owned by a user already created out of this module
```
  class { 'demarchessimplifiees':
    sysaccount_name   => 'dsuser',
    sysaccount_manage => false,
  }
```

### Merge behavior with hash $config

The parameter $config is a `Hash` with many keys.

If you call the class `demarchessimplifiees` directly in Puppet code, you will have to provide a value
for all keys that are not flagged as `Optional` in the custom data type `Demarchessimplifiees::Config`.
Details about custom data type in `REFERENCE.md`.

If you use hiera to store the values keys, then you only have to provide a value for keys you want to modify.
The others will use the default from hiera data of the module.

## Reference

Details in `REFERENCE.md` file.

## Limitations

Supported OSes are given is `metadata.json` file.

## Development

Home at URL https://gitlab.adullact.net/demarches-simplifiees/puppet-demarchessimplifiees

Issues and MR are welcome.

## Release Notes/Contributors/Etc.

```
Copyright (C) 2018 Association des Développeurs et Utilisateurs de Logiciels Libres
                     pour les Administrations et Colléctivités Territoriales.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/agpl.html>.

```

